--
--  $Id: rtems_shell.ads,v 1.2 2011/02/02 19:08:06 joel Exp $
--

with Command_Line_Arguments; use Command_Line_Arguments;
with Interfaces.C;           use Interfaces.C;
with Interfaces.C.Strings;   use Interfaces.C.Strings;
with Interfaces.C.Pointers;

package RTEMS_Shell is

   type Command_Function_Type is access function (ArgC : Argument_Count_Type;
      ArgV : Argument_Vector_Type) return int;
   pragma Convention (C, Command_Function_Type);

   procedure RTEMS_Shell_Add_Command(Name : chars_ptr; Category : chars_ptr;
      Help : chars_ptr; Command_Function : Command_Function_Type);
   pragma Import (C, RTEMS_Shell_Add_Command, "rtems_shell_add_cmd");

   type Prompt_Function_Type is access function return chars_ptr;
   pragma Convention (C, Prompt_Function_Type);

   procedure Set_RTEMS_Shell_Prompt_Function(
      Prompt_Function : Prompt_Function_Type);
   pragma Import (C, Set_RTEMS_Shell_Prompt_Function, "set_prompt_function");

   procedure Invoke_RTEMS_Shell;
   pragma Import (C, Invoke_RTEMS_Shell, "invoke_rtems_shell");

   procedure Initialize_Telnet_Daemon;
   pragma Import (C, Initialize_Telnet_Daemon, "init_telnet_daemon");

end RTEMS_Shell;
